//	o[LEDNX}Xc[ Ver.2
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
RGBtJ[10o[LED
keta index		9	8	7	6	5	4	3	2	1	0
(top_of_tree)[][][][][][][][][][](bottom_of_tree)
(top_of_tree)[][][][][][][][][][](bottom_of_tree)

y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	-	-
portB	Y	Gl	Gd	Gl	Gd	Gl	Gd	O	Yellow, Green/Light, Green/Dark, Orange
portD	x	R	R	cR	cB	sw	cG	-	Red, commonRed#, commonBlue#, INT0, commonGreen#	vg^Cv
portD	x	R	R	cB	cG	sw	cR	-	Red, commonBlue#, commonGreen#, INT0, commonRed#	p

yATtiny2313z	yOSX10201-LRPB2z
|-BBBBBBBBD|	20--------11
|V765432106|	|RROGGGGGGY|
>          |	|          |top_of_tree
|201102345G|	>RBG----GBR|
|ADDAADDDD-|	1---------10

yq[Yrbgz
Hoאݒ̂܂܁cLow:01100100(64), Hi:11011111(DF)

yrhz
Atmel Studio 6 (Version: 6.0.1996 - Service Pack 2)
AVR Toolchain 8 Bit / Version: 3.4.1.830 - GCC  4.6.2
ATtiny2313 1MHzi8MHz8j	œKIvV: -Os

yXVz
2013/11/15	v0.90	iO荞݂Ȃj
	Program Memory Usage 	:	1108 bytes   54.1 % Full
	Data Memory Usage 		:	45 bytes   35.2 % Full
	EEPROM Memory Usage 	:	2 bytes   1.6 % Full

2013/11/15	v1.00	Łivg^Cvj
	Program Memory Usage 	:	1284 bytes   62.7 % Full
	Data Memory Usage 		:	46 bytes   35.9 % Full
	EEPROM Memory Usage 	:	2 bytes   1.6 % Full

2013/12/07	v1.00	Łipj
	Program Memory Usage 	:	1284 bytes   62.7 % Full
	Data Memory Usage 		:	46 bytes   35.9 % Full
	EEPROM Memory Usage 	:	2 bytes   1.6 % Full
*/

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define NumOfLED	10
#define ColorBitLength	8

/*	vg^Cv
#define CommonRed		(1 << PD4)
#define CommonBlue		(1 << PD3)
#define CommonGreen		(1 << PD1)
*/
#define CommonRed		(1 << PD1)
#define CommonBlue		(1 << PD4)
#define CommonGreen		(1 << PD3)
#define CommonMask		(CommonRed | CommonBlue | CommonGreen)

//Œl̃rbg
#define	PortAFixedBits	((1 << PA1) | (1 << PA0))
#define	PortDFixedBits	((1 << PD2) | (1 << PD0))

enum ELedPattern
{
	LP_Alternate = 0,
	LP_Green = 1,
	LP_Blue = 2,
	
	LP_First = 0,
	LP_Last = 2
};

enum ELedPatternState
{
	LPST_Ready = 0,
	LPST_Fixed = 1
};

static	void	WaitButtonOff();
static	void	LedPatternFix();
static	void	LedOff();
static	void	LedOn(uint8_t ketaIdx, uint8_t commonBitName);
static	void	PreviewGreenTree();
static	void	PreviewBlueTree();
static	void	PreviewAlternateTree();
static	void	GreenTree();
static	void	BlueTree();
static	void	AlternateTree();

static	EEMEM	uint8_t	EM_LedPattern = LP_Alternate;
static	EEMEM	uint8_t	EM_LedPatternState = LPST_Ready;
static	uint8_t ledPattern, ledPatternState;

//10bƂ̌Ăяo^1ƂɃtO𗧂Ă
static	volatile	uint8_t	bPatternChange = 0;	//LED_p^[؂ւtO
static	volatile	uint8_t	bFixedCall = 0;	//LED_p^[mtO
static	volatile	uint8_t	tenSec = 0;		//1vJE^

ISR(TIMER1_COMPA_vect)
{
	bFixedCall = 1;
	if (++tenSec < 6) return;
	tenSec = 0;
	bPatternChange = 1;
}

//O荞
//E쒆̓X[v[hڍs̃gK[ƂȂB
//EX[v̓X[v̕ÃgK[ƂȂB
static	volatile	uint8_t	bStandby = 0;

ISR(INT0_vect)
{
	bStandby = 1;
}

//16bit^C}[荞݊Jn^~
#define	TimerOn()	(TIMSK |= (1 << OCIE1A))
#define	TimerOff()	(TIMSK &= ~(1 << OCIE1A))

//tOނZbg
static	void	InitParam()
{
	bPatternChange = 0;
	bFixedCall = 0;
	tenSec = 0;
	bStandby = 0;
}

int main(void)
{
	//|[g̓o͐ݒ
	DDRB	= 0b11111111;
	DDRD	= 0b01100000 | CommonMask;
	
	//d͍팸
	PORTA	= PortAFixedBits;	//gps^o̓svAbv
	PORTD	= PortDFixedBits;	//gps^o̓svAbv
	ACSR	= (1 << ACD);	//AiORp[^֎~
	
	//O荞ݐݒ
	MCUCR	= (0b00 << ISC00);	//Loxm
	GIMSK	= (1 << INT0);
	
	//16bit^C}[
	//WGM13,12,11,10: 0100=CTC
	//CS12,11,10: 000=^C}[~, 001=Ȃ, 010=8, 011=64, 100=256, 101=1024, 110=~[, 111=㏸[
	TCCR1A	= (0b00 << WGM10);
	TCCR1B	= (0b01 << WGM12) | (0b101 << CS10);	//1024 clk=1MHz/1024=1kHz
	OCR1A	= 10240 - 1;	//rln=1kHz*10sec=10240JEg
	
	sei();	//荞݋
	
MAIN_RESTART:
	LedOff();
	InitParam();
	
	//X[vJniO荞݂ŕAj
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);
	sleep_mode();	//X[vJn^X[v^X[v
	WaitButtonOff();
	
	//_p^[Zbg
	//ENA莞ԈȓɍċNxɓ_p^[ωB
	eeprom_busy_wait();
	ledPattern = eeprom_read_byte(&EM_LedPattern);
	eeprom_busy_wait();
	ledPatternState = eeprom_read_byte(&EM_LedPatternState);
	
	if (ledPatternState == LPST_Fixed)
	{
		ledPatternState = LPST_Ready;
		eeprom_busy_wait();
		eeprom_write_byte(&EM_LedPatternState, ledPatternState);
	}
	else
	{
		if (++ledPattern > LP_Last) ledPattern = LP_First;
		eeprom_busy_wait();
		eeprom_write_byte(&EM_LedPattern, ledPattern);
	}
	
	TimerOn();	//^C}[荞݊Jn
	
	switch (ledPattern)
	{
	case LP_Green:
		PreviewGreenTree();
		if (bStandby == 1) break;
		GreenTree();
		break;
		
	case LP_Blue:
		PreviewBlueTree();
		if (bStandby == 1) break;
		BlueTree();
		break;
		
	default:
	case LP_Alternate:
		PreviewAlternateTree();
		if (bStandby == 1) break;
		AlternateTree();
		break;
	}
	
	TimerOff();	//^C}[荞ݒ~
	WaitButtonOff();
	
	goto MAIN_RESTART;
	return 0;
}

//ꂽ{^܂Ŏ̏Ȃ悤ɑ҂iX[vA^sƂj
//E`^O΍̈ӖB
static	void	WaitButtonOff()
{
	LedOff();	//sɌĂяoꂽꍇALEDĂ玞ԑ҂
	_delay_ms(50);
	while (!(PIND & (1 << PD2))) _delay_ms(10);
	bStandby = 0;
}

//݂̓_p^[ۑ
//ENĈ莞ԌoߌɌĂяoB
static	void	LedPatternFix()
{
	bFixedCall = 0;
	if (ledPatternState == LPST_Fixed) return;
	if (ledPattern != LP_Alternate) TimerOff();	//^C}[荞ݒ~
	
	ledPatternState = LPST_Fixed;
	eeprom_busy_wait();
	eeprom_write_byte(&EM_LedPatternState, ledPatternState);
}

static	void	LedOff()
{
	PORTB = 0;
	PORTD = CommonMask | PortDFixedBits;
}

static	void	LedOn(uint8_t ketaIdx, uint8_t commonBitName)
{
	uint8_t	commonBit = CommonMask & ~commonBitName;
	uint8_t	portB = 0x00, portD = commonBit | PortDFixedBits;
	
	ketaIdx = (NumOfLED - 1) - ketaIdx;		//o[LEDi̐ݒuɍ킹邽߁AtɃ\[g
	if (2 <= ketaIdx)
	portB = (1 << (ketaIdx - 2)) & 0xFF;
	else
	portD |= (1 << (ketaIdx + 5)) & 0xFF;

	LedOff();	//o͂ύXOɈUi_Ci~bNhCuj
	PORTB = portB;
	PORTD = portD;
}

static	void	PreviewColor(uint8_t commonBitA, uint8_t commonBitB)
{
	uint8_t	i, keta;
	for (i = 0; i < 100; i++)	//_ԒiKɁj
	{
		for (keta = 0; keta < NumOfLED; keta++)
		{
			LedOn(keta, (keta & 0x01) ? commonBitB : commonBitA);
			_delay_ms(1);
			if (bStandby == 1) return;
		}
	}
}

static	void	PreviewGreenTree()
{
	PreviewColor(CommonGreen, CommonGreen);
}

static	void	PreviewBlueTree()
{
	PreviewColor(CommonBlue, CommonBlue);
}

static	void	PreviewAlternateTree()
{
	PreviewColor(CommonGreen, CommonBlue);
}

enum EIndexRGB
{
	IdxR = 0, IdxG = 1, IdxB = 2
};

//{R,G,B}	rgb=1k,0,0
static const uint8_t	ColorYellow[]		PROGMEM	= { 0b11101110, 0b11111111, 0b00000000 };
static const uint8_t	ColorGreenLight[]	PROGMEM	= { 0b00000000, 0b11111111, 0b00000000 };
static const uint8_t	ColorGreenDark[]	PROGMEM	= { 0b00000000, 0b10000000, 0b00000000 };
static const uint8_t	ColorOrange[]		PROGMEM	= { 0b10001000, 0b10000000, 0b00000000 };
static const uint8_t	ColorRed[]			PROGMEM	= { 0b11101110, 0b00000000, 0b00000000 };

static const uint8_t	*LedColorList_GreenTree[] =
{
	ColorYellow,
	ColorGreenLight,
	ColorGreenDark,
	ColorGreenLight,
	ColorGreenDark,
	ColorGreenLight,
	ColorGreenDark,
	ColorOrange,
	ColorRed,
	ColorRed
};

static	void	GreenTree()
{
	uint8_t	commonBit = 0;
	uint8_t loopCount = 0, blinkOn = 0;
	uint8_t	bitPos, bitMask, keta;
	
	while (1)
	{
		if (++loopCount & 0x04) blinkOn = 1 - blinkOn;	//F̓_Ń^C~O

		for (bitPos = 0; bitPos < ColorBitLength; bitPos++)
		{
			bitMask = (0xF0 >> bitPos) & 0xFF;
			for (keta = 0; keta < NumOfLED; keta++)
			{
				commonBit = 0x00;
				if (pgm_read_byte(&LedColorList_GreenTree[keta][IdxR]) & bitMask) commonBit |= CommonRed;
				if (pgm_read_byte(&LedColorList_GreenTree[keta][IdxG]) & bitMask) commonBit |= CommonGreen;
				if (pgm_read_byte(&LedColorList_GreenTree[keta][IdxB]) & bitMask) commonBit |= CommonBlue;

				if (keta == 0 && !blinkOn) commonBit = 0x00;	//F̓_
				LedOn(keta, commonBit);
			}
		}
		
		if (bFixedCall == 1) LedPatternFix();
		if (bPatternChange == 1) return;
		if (bStandby == 1) return;
	}
}

//{R,G,B}	rgb=1k,0,0
static const uint8_t	ColorPink[]			PROGMEM	= { 0b10101010, 0b00000000, 0b10000000 };
static const uint8_t	ColorDarkBlue[]		PROGMEM	= { 0b00000000, 0b00000000, 0b10000000 };
static const uint8_t	ColorDarkGreen[]	PROGMEM	= { 0b00000000, 0b10001000, 0b00000000 };
static const uint8_t	ColorSkyBlue[]		PROGMEM	= { 0b00000000, 0b10000000, 0b10001000 };
static const uint8_t	ColorWhite[]		PROGMEM	= { 0b11111110, 0b11111111, 0b11011010 };

static const uint8_t	*LedColorList_BlueTree[] =
{
	ColorPink,		//idx:0
	ColorWhite,		//idx:1	idx:6Ɠ
	ColorDarkBlue,	//idx:2
	ColorDarkBlue,	//idx:3
	ColorDarkBlue,	//idx:4
	ColorSkyBlue,	//idx:5
	ColorWhite,		//idx:6
	ColorOrange,
	ColorDarkGreen,
	ColorDarkGreen
};

static	void	BlueTree()
{
	uint8_t	commonBit = 0;
	uint8_t loopCount = 0;
	uint8_t	bitPos, bitMask, keta;
	int8_t	idx;
	
	while (1)
	{
		if (++loopCount % 32 == 0)	//uv^C~Oi͓KɁj
		{
			for (idx = 6; 2 <= idx; idx--)
				LedColorList_BlueTree[idx] = LedColorList_BlueTree[idx - 1];
			LedColorList_BlueTree[1] = LedColorList_BlueTree[6];
		}
		
		for (bitPos = 0; bitPos < ColorBitLength; bitPos++)
		{
			bitMask = (0xF0 >> bitPos) & 0xFF;
			for (keta = 0; keta < NumOfLED; keta++)
			{
				commonBit = 0x00;
				if (pgm_read_byte(&LedColorList_BlueTree[keta][IdxR]) & bitMask) commonBit |= CommonRed;
				if (pgm_read_byte(&LedColorList_BlueTree[keta][IdxG]) & bitMask) commonBit |= CommonGreen;
				if (pgm_read_byte(&LedColorList_BlueTree[keta][IdxB]) & bitMask) commonBit |= CommonBlue;
				LedOn(keta, commonBit);
			}
		}
		
		if (bFixedCall == 1) LedPatternFix();
		if (bPatternChange == 1) return;
		if (bStandby == 1) return;
	}
}

static	void	AlternateTree()
{
	while (1)
	{
		bPatternChange = 0;
		GreenTree();
		if (bStandby == 1) return;
		
		bPatternChange = 0;
		BlueTree();
		if (bStandby == 1) return;
	}
}
